// File FFBRMSYS.CPP Broom Balancing Feedforward Network
//               Turbo Vision interface

#include <conio.h>

extern "C" {
   #include "ffbrm.h"
   }

#include "ffbrmsetp.cpp"

void handle_system (system_response *control_flag)
  {
   tffbrmsetapp *Setup_App = new tffbrmsetapp();
   quit_flag = quit;
   if (*control_flag == startup) {
      g_ff_setup.shuffle = FALSE;
      g_ff_setup.no_of_inputs = 5;
      g_ff_setup.no_of_h1_nodes = 20;
      g_ff_setup.no_of_outputs = 1;
      g_ff_setup.sigmoid_out = TRUE;
      }
   Setup_App->run();
   Setup_App->destroy (Setup_App);
   *control_flag = quit_flag;
   return;
   }

int main()
   {
   system_response prog_control = startup;
   initialize_ff_setup (&g_ff_setup);
   initialize_brm_setup (&g_brm_setup);
   strcpy (system_name,"Broom Balancing");
   display_startup_message();
   do
   {
   handle_system(&prog_control);
   switch (prog_control) {
   case train_net:
	train_look_ahead_network (g_ff_setup);
	break;
   case training_data:
	create_training_file (g_ff_setup);
	break;
   case run_net:
	run_ff_controller (g_ff_setup);
	break;
   case special:
	broom_game (g_brm_setup);
	break;
   }
   } while (prog_control != quit);
   return 0;
   } // end main