/*  File FLBRMBAL.C  Fuzzy Logic Broom Balancing */

#ifndef FLBRMBAL_C
#define FLBRMBAL_C

#include <math.h>
#include <conio.h>
#include <alloc.h>
#include "flbrm.h"

float fuzzy_logic_force (state_rec the_state) {
   float x[4],force;
   x[in_theta] = the_state.theta;
   x[in_theta_dot] = the_state.theta_dot;
   x[in_x] = the_state.x_pos;
   x[in_x_dot] = the_state.x_dot;
   force = fuzzy_system(x,g_fuzzy_system);
   /* Note:  zero_theta is used here as a threshold for force, not angle */
   if (fabs(force) < g_brm_setup.zero_theta) return 0.0;
   if (force > 0.0) return g_brm_setup.system_force_incr;
   if (force < 0.0) return -g_brm_setup.system_force_incr;
   return force;
   }

void run_fuzzy_logic_controller (tbrm_setup_rec brm_set) {
   clrscr();
   textcolor (YELLOW);
   gotoxy (1,5);
   cputs ("Fuzzy Logic Broom Balancing Controller Program");
   gotoxy (1,7);
   cputs ("Press any key to start (esc to cancel): ");
   if (getch() == ESC_KEY) return;
   init_flbrm_fuzzy_system (&g_fuzzy_system);
   control_system ("Fuzzy Logic Broom Balancer",brm_set,&fuzzy_logic_force);
   free (g_fuzzy_system.rules);
   textmode (LASTMODE);
   return;
   }

#endif