/* File SLFBRM.H  Header file for self organizing broom balancer */

#ifndef SLFBRM_H
#define SLFBRM_H

#include "utgr.h"
#include "uttypes.h"
#include "ui.h"
#include "brm.h"

#define NO_OF_INPUTS 4   /* Number of state vector components */
#define NO_OF_INP_WTS 3  /* Number of input weight components */

typedef struct {
   file_names_rec the_files;
   unsigned short read_wts_from_file;
   int graph_layer,graph_coord_1,graph_coord_2;
   int lattice_rows,lattice_cols,lattice_k;
   int freq;  /* How often to display graphics screen */
   float starting_stepsize,
	 x_pos_param,  /* Relative weight of x_pos and */
	 theta_dot_param,   /* theta_dot in reward function */
	 force_factor; /* Magnitude of controller force */
   int starting_nbhd;
   int iter_interval;
   short color;
   graph_setup_rec gr_rec; } slb_setup_rec;

extern slb_setup_rec slb_rec;
void initialize_self_org_brm_setup (slb_setup_rec *the_rec);

/*  File SLBFILES.C  Read and write weights files  */
short read_weights (float ****w_in,float ***w_out,slb_setup_rec s);
short write_weights (float ****w_in,float ***w_out,slb_setup_rec s);

/* File SLBTRN.C Train a Self Organizing Neural Network for Broom Balancing*/
void self_org_brm_train (slb_setup_rec s);

/* File SLBRUN.C  Run Self Org Broom Balancer  */
void run_self_org_controller(slb_setup_rec s);

#endif