/*  File UT.H  Header file for utility UT*.C files */

#ifndef UT_H
#define UT_H

#include <stdio.h>
#include "uttypes.h"

/* UTMATRIX.C */
float **matrix2d (int rows_lower_lim,int rows_upper_lim,
   int cols_lower_lim,int cols_upper_lim);
float ***matrix3d (int rows_lower_lim,int rows_upper_lim,
   int cols_lower_lim,int cols_upper_lim,int n_lower_lim,int n_upper_lim);
float ****matrix4d (int rows_lower_lim,int rows_upper_lim,
   int cols_lower_lim,int cols_upper_lim,
   int m_lower_lim,int m_upper_lim,
   int n_lower_lim,int n_upper_lim);
void rand_init_3d_matrix (float ***w,int l_rows,int l_cols,int n_inp,
     float range);
void init_3d_matrix (float ***w,int l_rows,int l_cols,int n_inp,
     const float val);
void rand_init_4d_matrix (float ****w,int l_rows,int l_cols,int m_inp,
   int n_inp, float range);
void rand_init_2d_matrix (float **w, int l_rows, int l_cols,float range);
void init_2d_matrix (float **a, int l_rows, int l_cols, const float val);
void free_matrix2d (float **a,int rows_lower_lim,int cols_lower_lim);
void free_matrix3d (float ***a,int rows_lower_lim,int cols_lower_lim,
   int n_lower_lim);
void free_matrix4d (float ****a,int rows_lower_lim,int cols_lower_lim,
   int m_lower_lim,int n_lower_lim);
short write_2d_matrix (float **w,int l_rows,int l_cols,char *file_name);
void print_2d_matrix (float **w,int l_rows,int l_cols);
short read_2d_matrix (float **w,char *file_name,int rows,int cols);
short write_3d_matrix (float ***w,int l_rows,int l_cols,int n_inp,
   char *file_name);
void print_3d_matrix (float ***w,int rows,int cols,int inp);
void print_4d_matrix (float ****w,int rows,int cols,int inp,int inp2);
short read_3d_matrix (float ***w,char *file_name,int rows,int cols,int inp);
short write_4d_matrix (float ****w,int l_rows,int l_cols,int m_inp,
   int l_inp,char *file_name);
short read_4d_matrix (float ****w,char *file_name,int rows,int cols,
   int inp,int inp2);

/* UTFILES.C */
long open_input_text_file (FILE **the_file,path_str file_name);
short open_output_text_file (FILE **the_file,path_str file_name);
int fcopy (const char far *,const char far*);

/*  UTPRCS.C  */
char get_answer (char chr1,char chr2,char chr3,char chr4);
int cget_int (int len,int *value);
int cget_float (int len,float *value);
void  shuffl (int no_of_items,int *pshuffle_list);
float frand (void);

/*  UTVECT.C  */
ui_vector allocate_ui_vector (int low_limit,int up_limit);
f_vector allocate_f_vector (int low_limit,int up_limit);
d_vector allocate_d_vector (int low_limit,int up_limit);
void copy_ui_vector (ui_vector source,ui_vector dest,int start,int len);
void copy_f_vector (f_vector source,f_vector dest,int start,int len);
void copy_d_vector (d_vector source,d_vector dest,int start,int len);
void free_ui_vector (ui_vector v,int low_limit);
void free_f_vector (f_vector v,int low_limit);
void free_d_vector (d_vector v,int low_limit);

#endif