/*  File UTPRCS.C  General utility procedures  */

#ifndef UTPRCS_C
#define UTPRCS_C

#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <time.h>
#include <math.h>
#include "ut.h"

char get_answer (char chr1,char chr2,char chr3,char chr4);
int cget_int (int len,int *value);
int cget_float (int len,float *value);
void  shuffl (int no_of_items,int *pshuffle_list);
float frand (void);

/*  Implementation  */

char get_answer (char chr1,char chr2,char chr3,char chr4) {
   /* Accepts one of 4 possible keyboard inputs, or ESC_KEY */
   short col,row;
   char answer;
   col = wherex();
   row = wherey();
   do {
     gotoxy (col,row);
     answer = getch();
     if (answer == ESC_KEY) return answer;
     } while (!((answer == chr1)||(answer == chr2)||
	     (answer == chr3)||(answer == chr4)));
     return answer;
     }  /*  end proc */

int cget_int (int len,int *value) {
    /* Returns length of successful numeric scan (0 if invalid numeric) */
    char temp[20];
    temp[0] = len;
    cgets (temp);
    if (temp[1] > 0)
       return sscanf ((char *)&temp[2],"%d",value);
    return 0;
    }

int cget_float (int len,float *value) {
    /* Returns length of successful numeric scan (0 if invalid numeric) */
    char temp[20];
    temp[0] = len;
    cgets (temp);
    if (temp[1] > 0)
       return sscanf ((char *)&temp[2],"%f",value);
    return 0;
    }

void  shuffl (int no_of_items,int *pshuffle_list) {
   /* When done, *pshuffle_list contains the numbers 0..no_of_items-1 */
   /* in shuffled order. */
   int i,j,k,n,remaining_items;
   int *pnumber_list;
   pnumber_list = (int *) malloc (no_of_items * sizeof(int));
   randomize();
   remaining_items = no_of_items;
   for (i = 0;i < no_of_items;i++) {
       pshuffle_list [i] = 0;
       pnumber_list [i] = i;
       }  /*  end i  */
   n = 0;
   while (remaining_items >= 1) {
       k = random (remaining_items);
       pshuffle_list [n] = pnumber_list [k];
       remaining_items--;
       /*  Remove k from number_list:  */
       for (j = k;j<remaining_items;j++)
	   pnumber_list [j] = pnumber_list [j+1];
       n++;
       }  /* end while */
    free (pnumber_list);
    }  /*  end proc  */

float frand (void) {
   /* Floating point random number generator  */
   /* Returns random number between 0 and 1  */
   return rand()/(RAND_MAX + 1.0);
   }

#endif
